Loading...
Searching...
No Matches
Sip_cseq

## Data Structures

struct | sip_cseq_s
| Structure for CSeq header. More...

## Macros

#define | sip_cseq(sip)
| Access a SIP CSeq header structure sip_cseq_t from sip_t.
#define | SIP_CSEQ_INIT()
| Initializer for structure sip_cseq_t.
#define | SIPTAG_CSEQ(x)
| Tag list item for pointer to a CSeq header structure sip_cseq_t.
#define | SIPTAG_CSEQ_REF(x)
| Tag list item for reference to a CSeq header pointer.
#define | SIPTAG_CSEQ_STR(s)
| Tag list item for string with CSeq header value.
#define | SIPTAG_CSEQ_STR_REF(x)
| Tag list item for reference to a CSeq header string.

## Typedefs

typedef struct sip_cseq_s | sip_cseq_t
| @

## Functions

issize_t | sip_cseq_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP CSeq header.
issize_t | sip_cseq_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP CSeq header.
sip_cseq_t * | sip_cseq_init (sip_cseq_t x[1])
| Initialize a structure sip_cseq_t.
int | sip_is_cseq (sip_header_t const *header)
| Test if header object is instance of sip_cseq_t.
sip_cseq_t * | sip_cseq_dup (su_home_t *home, sip_cseq_t const *hdr))
| Duplicate a list of CSeq header header structures sip_cseq_t.
sip_cseq_t * | sip_cseq_copy (su_home_t *home, sip_cseq_t const *hdr))
| Copy a list of CSeq header header structures sip_cseq_t.
sip_cseq_t * | sip_cseq_make (su_home_t *home, char const *s))
| Make a CSeq header structure sip_cseq_t.
sip_cseq_t * | sip_cseq_format (su_home_t *home, char const *fmt,...)))
| Make a CSeq header from formatting result.
sip_cseq_t * | sip_cseq_create (su_home_t *home, uint32_t seq, unsigned method, char const *method_name)
| Create a CSeq header object.

## Variables

msg_hclass_t | sip_cseq_class []
| Header class for CSeq header.
tag_typedef_t | siptag_cseq
| Tag for CSeq header object.
tag_typedef_t | siptag_cseq_str
| Tag for string with CSeq header value.

## Detailed Description

## Macro Definition Documentation

## SIP_CSEQ_INIT

#define SIP_CSEQ_INIT | ( |  | ) |

Initializer for structure sip_cseq_t.

A static sip_cseq_t structure for CSeq header must be initialized with the SIP_CSEQ_INIT() macro. For instance,

sip_cseq_t sip_cseq = SIP_CSEQ_INIT;
sip_cseq
#define sip_cseq(sip)
Access a SIP CSeq header structure sip_cseq_t from sip_t.
Definition sip_protos.h:2511
SIP_CSEQ_INIT
#define SIP_CSEQ_INIT()
Initializer for structure sip_cseq_t.
Definition sip_protos.h:2528
sip_cseq_t
struct sip_cseq_s sip_cseq_t
@
Definition sip.h:148

## SIPTAG_CSEQ

#define SIPTAG_CSEQ | ( |  | x | ) |

Tag list item for pointer to a CSeq header structure sip_cseq_t.

The SIPTAG_CSEQ() macro is used to include a tag item with a pointer to a sip_cseq_t structure in a tag list.

Parameters

  x | pointer to a sip_cseq_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_CSEQ_REF().

## SIPTAG_CSEQ_STR

#define SIPTAG_CSEQ_STR | ( |  | s | ) |

Tag list item for string with CSeq header value.

The SIPTAG_CSEQ_STR() macro is used to include a tag item with a string containing value of a sip_cseq_t header in a tag list.

Parameters

  s | pointer to a string containing CSeq header value, or NULL.

The string in SIPTAG_CSEQ_STR() can be converted to a sip_cseq_t header structure by giving the string s has second argument to function sip_cseq_make().

The corresponding tag taking reference parameter is SIPTAG_CSEQ_STR_REF().

## Typedef Documentation

## sip_cseq_t

typedef struct sip_cseq_s sip_cseq_t

@

The CSeq header (command sequence) uniquely identifies transactions within a dialog. It is defined in RFC 3261 as follows:

CSeq = "CSeq" HCOLON 1*DIGIT LWS Method
Method = INVITEm / ACKm / OPTIONSm / BYEm
/ CANCELm / REGISTERm
/ extension-method
extension-method = token
DIGIT
#define DIGIT
LWS
#define LWS

The parsed CSeq header is stored in sip_cseq_t structure.

The structure sip_cseq_t contains representation of SIP CSeq header.

The sip_cseq_t is defined as follows:

typedef struct sip_cseq_s {
sip_common_t cs_common[1]; // Common fragment info
sip_error_t *cs_next; // Link to next (dummy)
uint32_t cs_seq; // Sequence number
sip_method_t cs_method; // Method enum
char const *cs_method_name; // Method name
} sip_cseq_t;
sip_error_t
msg_error_t sip_error_t
@
Definition sip.h:134
sip_common_t
msg_common_t sip_common_t
Common part of all the header structures.
Definition sip.h:121
sip_method_t
sip_method_t
IDs for well-known SIP methods.
Definition sip.h:48
sip_cseq_s
Structure for CSeq header.
Definition sip.h:461
sip_cseq_s::cs_common
sip_common_t cs_common[1]
Common fragment info.
Definition sip.h:462
sip_cseq_s::cs_method
sip_method_t cs_method
Method enum.
Definition sip.h:465
sip_cseq_s::cs_seq
uint32_t cs_seq
Sequence number.
Definition sip.h:464
sip_cseq_s::cs_method_name
char const * cs_method_name
Method name.
Definition sip.h:466
sip_cseq_s::cs_next
sip_error_t * cs_next
Link to next (dummy).
Definition sip.h:463
uint32_t
SU_U32_T uint32_t

## Function Documentation

## sip_cseq_copy()

sip_cseq_t * sip_cseq_copy | ( | su_home_t * | home,
|  | sip_cseq_t const * | hdr )

inline

Copy a list of CSeq header header structures sip_cseq_t.

The function sip_cseq_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  cseq = sip_cseq_copy(home, sip->sip_cseq);
  sip_cseq_copy
  sip_cseq_t * sip_cseq_copy(su_home_t *home, sip_cseq_t const *hdr))
  Copy a list of CSeq header header structures sip_cseq_t.
  Definition sip_protos.h:2658

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_cseq_create()

sip_cseq_t * sip_cseq_create | ( | su_home_t * | home,
|  | uint32_t | seq,
|  | unsigned | method,
|  | char const * | method_name )

Create a CSeq header object.

Create a CSeq header object.

Create a CSeq header object with the sequence number seq, method enum method and method name method_name. The memory for the header object is allocated from the memory home home.

Parameters

  home | memory home
  seq | sequence number
  method | method enum
  method_name | method name (required if method is not well-known)

Example
  The following code fragment creates a cseq object for OPTIONS request:
  sip_cseq_t *cseq;
  cseq = sip_cseq_create(home, agent->seq++, SIP_METHOD_OPTIONS);
  sip_cseq_create
  sip_cseq_t * sip_cseq_create(su_home_t *, uint32_t seq, unsigned method, char const *name)
  Create a CSeq header object.
  Definition sip_basic.c:1280

Returns
  A pointer to newly created CSeq header object when successful or NULL upon an error.

## sip_cseq_dup()

sip_cseq_t * sip_cseq_dup | ( | su_home_t * | home,
|  | sip_cseq_t const * | hdr )

inline

Duplicate a list of CSeq header header structures sip_cseq_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  cseq = sip_cseq_dup(home, sip->sip_cseq);
  sip_cseq_dup
  sip_cseq_t * sip_cseq_dup(su_home_t *home, sip_cseq_t const *hdr))
  Duplicate a list of CSeq header header structures sip_cseq_t.
  Definition sip_protos.h:2615

Returns
  A pointer to the newly duplicated sip_cseq_t header structure, or NULL upon an error.

## sip_cseq_format()

sip_cseq_t * sip_cseq_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a CSeq header from formatting result.

Make a new sip_cseq_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_cseq_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_cseq_init()

sip_cseq_t * sip_cseq_init | ( | sip_cseq_t | x[1] | ) |

inline

Initialize a structure sip_cseq_t.

An sip_cseq_t structure for CSeq header can be initialized with the sip_cseq_init() function/macro. For instance,

sip_cseq_t sip_cseq;
sip_cseq_init(&sip_cseq);
sip_cseq_init
sip_cseq_t * sip_cseq_init(sip_cseq_t x[1])
Initialize a structure sip_cseq_t.
Definition sip_protos.h:2546

## sip_cseq_make()

sip_cseq_t * sip_cseq_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a CSeq header structure sip_cseq_t.

The function sip_cseq_make() makes a new sip_cseq_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_cseq_t header structure, or NULL upon an error.

## sip_is_cseq()

int sip_is_cseq | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_cseq_t.

Check if the header class is an instance of CSeq header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header cseq
  0 | (false) otherwise

## Variable Documentation

## sip_cseq_class

msg_hclass_t sip_cseq_class[]

extern

Header class for CSeq header.

The header class sip_cseq_class defines how a SIP CSeq header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_cseq_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.